Bug 531270

Summary: TG3, kvm, ipv6 & tso data corruption bug
Product: [Fedora] Fedora Reporter: Rik van Riel <riel>
Component: kernelAssignee: Rik van Riel <riel>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: high    
Version: 13CC: benlu, bloch, dougsland, gansalmon, herbert.xu, itamar, kernel-maint, knoel, markmc, mcarlson, slukasik
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-06-27 10:28:34 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 498969    
Attachments:
Description Flags
tg3: Enable IPv6 LSO offload in hardware none

Description Rik van Riel 2009-10-27 10:30:50 EDT
Description of problem:

Doing a large rsync-over-ssh from a RHEL 5 KVM guest (running on F12 beta) to a physical host elsewhere on my network results in a "Corrupted MAC on input." error message from ssh, which means data inside the TCP stream got corrupted.

Worse still, the packet checksum on the packet with the corrupted data is correct, because the packet did not get dropped by the receiving host. This suggests that the packet gets corrupted in-between the time the host receives the packet from the guest and the time the NIC calculates the packet's checksum.

Disabling checksum offload on the host makes the corruption go away.  Possibly this is because the checksum gets calculated earlier, before the window during which packets get corrupted. Of course, I do not know the network code all that well so I may be wrong :)

Version-Release number of selected component (if applicable):

2.6.31.1-56.fc12.x86_64

Steps to Reproduce:
1. run a RHEL 5 KVM guest on F12 beta
2. do a gigantic rsync-over-ssh from the guest to an outside system
3. wait for ssh error message 

Additional info:

The NIC on my host is the following, which uses the tg3 driver:

05:00.0 Ethernet controller: Broadcom Corporation NetXtreme BCM5761 Gigabit Ethernet PCIe (rev 10)
Comment 1 Rik van Riel 2009-10-27 18:02:12 EDT
So far it looks like the problem only happens with ipv6 packets.  I will keep running the test today to make sure of this.
Comment 2 Rik van Riel 2009-10-28 09:44:48 EDT
OK, so far I have this info:

ipv4         => no problem
ipv6 w/ tso  => data corruption
ipv6 w/o tso => no problem

It looks like either the NIC or the network driver has issues with ipv6 and TSO.
Comment 3 Rik van Riel 2009-10-28 11:00:59 EDT
I have reported the bug upstream:

http://lkml.org/lkml/2009/10/28/189
Comment 4 Chuck Ebbert 2009-11-02 10:38:33 EST
It's a long shot, but can you try this scratch build when/if it finishes? There is a fix for a TSO bug in it:

http://koji.fedoraproject.org/koji/taskinfo?taskID=1782682
Comment 5 Matt Carlson 2009-11-06 12:29:31 EST
Created attachment 367852 [details]
tg3: Enable IPv6 LSO offload in hardware

This patch enables hardware IPv6 LSO offload support for the 5761
and 5717.

Does this patch fix the problem?
Comment 6 Bug Zapper 2010-03-15 08:58:36 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 13 development cycle.
Changing version to '13'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Bug Zapper 2011-06-02 13:33:12 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Bug Zapper 2011-06-27 10:28:34 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.